unit captwnd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, Menus;

type
  TCapturedData = class(TForm)
    Image1: TImage;
    StatusBar1: TStatusBar;
    PopupMenu1: TPopupMenu;
    CopytoClipboard1: TMenuItem;
    SavetoFile1: TMenuItem;
    SaveDialog1: TSaveDialog;
    procedure Image1DblClick(Sender: TObject);
    procedure CopytoClipboard1Click(Sender: TObject);
    procedure SavetoFile1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
  public
    ImageWidth: Integer;
    ImageHeight: Integer;
  published
  end;

var
  CapturedData: TCapturedData;

implementation

{$R *.DFM}

uses clipbrd, main, jpeg;

procedure TCapturedData.Image1DblClick(Sender: TObject);
begin
  CapturedData.ClientWidth := ImageWidth;
  CapturedData.ClientHeight := ImageHeight + StatusBar1.Height;
end;

procedure TCapturedData.CopytoClipboard1Click(Sender: TObject);
var
  MyFormat: Word;
  AData: THandle;
  APalette: hPalette;
begin
  Image1.Picture.SaveToClipBoardFormat(MyFormat, AData, APalette);
  ClipBoard.SetAsHandle(MyFormat, AData);
end;

procedure TCapturedData.SavetoFile1Click(Sender: TObject);
var
  jp: TJpegImage;
begin
  SaveDialog1.DefaultExt := '.bmp';
  SaveDialog1.Filter := 'Bitmap files (*.bmp)|*.bmp|JPEG files (*.jpg)|*.jpg|All files (*.*)|*.*';
  SaveDialog1.Options := [ofOverwritePrompt, ofHideReadOnly];
  if SaveDialog1.Execute then begin
    if CompareText(ExtractFileExt(SaveDialog1.FileName), '.bmp') = 0 then begin
      Image1.Picture.SaveToFile(SaveDialog1.FileName);
    end else if CompareText(ExtractFileExt(SaveDialog1.FileName), '.jpg') = 0 then begin
      jp := TJpegImage.Create;
      try
        with jp do begin
          Assign(Image1.Picture.Bitmap);
          SaveToFile(SaveDialog1.FileName);
        end;
      finally
        jp.Free;
      end;
    end else begin
      MessageDlg('Filnamnet mste sluta p antingen .bmp eller .jpg, s jag vet i vilket format jag ska spara!', mtError, [mbOK], 0);
    end;
  end;
end;

procedure TCapturedData.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caHide;
end;

procedure TCapturedData.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key in [' '..#255] then begin
    StatusBar1.SimpleText := StatusBar1.SimpleText + Key;
  end;
end;

procedure TCapturedData.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DELETE) or (Key = VK_BACK) then begin
    with StatusBar1 do begin
      SimpleText := Copy(SimpleText, 1, Length(SimpleText) - 1);
    end;
  end else if (Key = Ord('X')) and (ssCtrl in Shift) then begin
    StatusBar1.SimpleText := '';
  end else if Key = VK_F3 then begin
    if Assigned(MainForm) then MainForm.Visible := not MainForm.Visible;
  end;
end;

end.

